﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using Tao.OpenGl;
///
///Created by: Shady Ahmed El-Yaski
///Email: shady@elyaski.com
///
namespace My_Snake
{
    public partial class Form1 : Form
    {
        List<Point> Snake_List;
        double xpos, ypos;
        double blockX, blockY;
        Random r;
        int score;
        Keys key, keyLast;
        bool firsttime = true, firstpaint = true;
        public Form1()
        {
            InitializeComponent();
            InitializationOpenGL();
        }
        private void InitializationOpenGL()
        {
            this.Text = "My Snake";
            this.Level.Text = "Level 1";
            this.Score_txt.Text = "0";
            this.timer1.Interval = 150;
            xpos = 0; ypos = 0;
            blockX = 0; blockY = 0;
            score = 0;
            r = new Random();
            Snake_List = new List<Point>();
            simpleOpenGlControl1.InitializeContexts();
            Gl.glMatrixMode(Gl.GL_PROJECTION);
            Gl.glLoadIdentity();
            Glu.gluOrtho2D(-100, 100, -100, 100);
            Gl.glMatrixMode(Gl.GL_MODELVIEW);
            Gl.glLoadIdentity();
            Gl.glClearColor(1f, 1f, 1f, 1);
            Gl.glClear(Gl.GL_COLOR_BUFFER_BIT);
            Snake_List.Add(new Point((int)xpos, (int)ypos));
            
        }

        private void simpleOpenGlControl1_Paint(object sender, PaintEventArgs e)
        {
            for (int i = 0; i < Snake_List.Count; i++)
            {
                Gl.glPushMatrix();
                if (i == 0)
                    Gl.glColor3f(0f, 0f, 1f);
                else
                    Gl.glColor3f(0f, 0f, 0f);
                Gl.glTranslated(Snake_List[i].X, Snake_List[i].Y, 0);
                if (Square.Checked)
                    Gl.glRectf(-80f, 80f, -72f, 72f);
                else if (Triangle.Checked)
                {
                    Gl.glBegin(Gl.GL_TRIANGLES);
                    Gl.glVertex2f(-80, 72);
                    Gl.glVertex2f(-72, 72);
                    Gl.glVertex2f(-76, 80);
                    Gl.glEnd();
                }
                else if (Circle.Checked)
                {
                    int r = 5;
                    float delta_theta = 0.01f;
                    Gl.glBegin(Gl.GL_POLYGON);
                    for (float angle = 0; angle < 2 * Math.PI; angle += delta_theta)
                        Gl.glVertex3d(r * Math.Cos(angle) - 76, r * Math.Sin(angle) + 76, 0);
                }
                Gl.glEnd();
                Gl.glPopMatrix();
            }
            
        }

        private void draw_random_block()
        {
            Gl.glClear(Gl.GL_COLOR_BUFFER_BIT);
            int neg = r.Next(-5, 5);
            blockX = r.Next(11) * 8 * (neg > 0 ? 1 : -1);
            neg = r.Next(-5, 5);
            blockY = r.Next(11) * 8 * (neg > 0 ? 1 : -1);
            Gl.glPushMatrix();
            Gl.glColor3f(1f, 0f, 0f);
            Gl.glRectf((float)blockX, (float)blockY, (float)blockX + 8, (float)blockY - 8);
            Gl.glPopMatrix();
            Gl.glFlush();
        }

        private void check_score()
        {
            if (score == 30)
            {
                this.timer1.Interval = 100;
                this.Level.Text = "Level 2";
            }
            else if (score == 50)
            {
                this.timer1.Interval = 80;
                this.Level.Text = "Level 3";
            }
            else if (score == 70)
            {
                this.timer1.Interval = 60;
                this.Level.Text = "Level 4";
            }
            else if (score == 100)
            {
                this.timer1.Interval = 40;
                this.Level.Text = "Level 5";
            }
            else if (score == 130)
            {
                this.timer1.Interval = 20;
                this.Level.Text = "Level 6";
            }
            else if (score == 150)
            {
                this.timer1.Interval = 10;
                this.Level.Text = "Level 7";
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
                Gl.glClear(Gl.GL_COLOR_BUFFER_BIT);
                check_score();
                if (firstpaint)
                {
                    draw_random_block();
                    firstpaint = false;
                }
                else
                {
                    Gl.glLoadIdentity();
                    Gl.glColor3f(1f, 0f, 0f);
                    Gl.glRectf((float)blockX, (float)blockY, (float)blockX + 8, (float)blockY - 8);
                }
                if (Check_collision() == 1)
                {
                    score += 10;
                    Snake_List.Add(new Point((int)Snake_List[Snake_List.Count - 1].X, (int)Snake_List[Snake_List.Count - 1].Y));
                    draw_random_block();
                }
                else if (Check_collision() == 2)
                {
                    this.Level.Text = "Game Over!!";
                    this.Text += "   Game Over!";
                    this.timer1.Enabled = false;
                    return;
                }
                if (key == Keys.D && keyLast == Keys.A)
                    keyLast = Keys.D;
                if (key == Keys.A && keyLast == Keys.D)
                    keyLast = Keys.A;
                if (key == Keys.W && keyLast == Keys.S)
                    keyLast = Keys.W;
                if (key == Keys.S && keyLast == Keys.W)
                    keyLast = Keys.S;
                Point p;

                switch (keyLast)
                {
                    case Keys.W:
                        for (int i = Snake_List.Count - 1; i > 0; i--)
                        {
                            Point pp = Snake_List[i - 1];
                            Snake_List[i] = pp;
                        }
                        p = Snake_List[0];
                        Snake_List[0] = new Point(p.X, p.Y + 8);
                        ypos += 8;
                        break;
                    case Keys.S:
                        for (int i = Snake_List.Count - 1; i > 0; i--)
                        {
                            Point pp = Snake_List[i - 1];
                            Snake_List[i] = pp;
                        }
                        p = Snake_List[0];
                        Snake_List[0] = new Point(p.X, p.Y - 8);
                        ypos -= 8;
                        break;
                    case Keys.A:
                        for (int i = Snake_List.Count - 1; i > 0; i--)
                        {
                            Point pp = Snake_List[i - 1];
                            Snake_List[i] = pp;
                        }
                        p = Snake_List[0];
                        Snake_List[0] = new Point(p.X - 8, p.Y);
                        xpos -= 8;
                        break;
                    case Keys.D:
                        for (int i = Snake_List.Count - 1; i > 0; i--)
                        {
                            Point pp = Snake_List[i - 1];
                            Snake_List[i] = pp;
                        }
                        p = Snake_List[0];
                        Snake_List[0] = new Point(p.X + 8, p.Y);
                        xpos += 8;
                        break;
                }

                key = keyLast;
                simpleOpenGlControl1.Refresh();
                this.Score_txt.Text = score.ToString();
        }

        private int Check_collision()
        {
            if ((-80 + xpos) == blockX && 80 + ypos == blockY && (-72 + xpos) == blockX + 8 && 72 + ypos == blockY - 8)
                return 1;
            if ((-80 + xpos) >= 92 || (-80 + xpos) <= -100 || (80 + ypos) >= 100 || (80 + ypos) <= -92)
                return 2;

            for (int i = 1; i < Snake_List.Count; i++)
            {
                if (xpos == Snake_List[i].X && ypos == Snake_List[i].Y)
                    return 2;
            }

            return -1;
        }

        private void simpleOpenGlControl1_KeyDown(object sender, KeyEventArgs e)
        {
            keyLast = e.KeyCode;
            if (firsttime)
            {
                key = keyLast;
                this.timer1.Enabled = true;
                firsttime = false;
            }
            if (keyLast == Keys.P)
                this.timer1.Enabled = false;
            else
                this.timer1.Enabled = true;
        }

        private void reset_Click(object sender, EventArgs e)
        {
            this.timer1.Enabled = false;
            if (MessageBox.Show("Reset the game?", "Reset", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                InitializationOpenGL();
                xpos = 0;
                ypos = 0;
                score = 0;
                firstpaint = true;
                firsttime = true;
                this.simpleOpenGlControl1.Focus();
                this.timer1.Enabled = false;
                this.simpleOpenGlControl1.Refresh();
            }
            else
                this.timer1.Enabled = true;

        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {
            this.simpleOpenGlControl1.Focus();
        }


    }
}